#!/bin/bash
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:$PATH

: '
Copyright (C) 2022 - now  HaoZi Technology Co., Ltd.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
'

source <(curl -f -s --connect-timeout 10 --retry 3 https://dl.cdn.haozi.net/panel/public.sh)
if [ $? -ne 0 ]; then
    echo "下载 public.sh 失败,请检查网络或稍后重试。"
    echo "Download public.sh failed, please check the network or try again later."
    exit 1
fi

channel=${1}
version=${2}
postgresql_path="${setup_path}/server/postgresql"
j=$(calculate_j)

# 安装依赖
if [ ${OS} == "rhel" ]; then
    dnf makecache -y
    dnf groupinstall "Development Tools" -y
    dnf install pkg-config make bison flex gettext zlib-devel readline-devel icu libicu libicu-devel libxml2-devel libxslt-devel openssl-devel systemd-devel -y
elif [ ${OS} == "debian" ] || [ ${OS} == "ubuntu" ]; then
    apt-get update
    apt-get install build-essential pkg-config make bison flex gettext zlib1g-dev libreadline-dev icu-devtools libicu-dev libxml2-dev libxslt-dev libssl-dev libsystemd-dev -y
else
    error "不支持的操作系统"
fi

# 预检查
systemctl is-active --quiet postgresql
if [ "$?" != "0" ]; then
    error "应用运行状态不正常"
fi

# 停止已有服务
systemctl stop postgresql

# 准备目录
cd ${postgresql_path}
rm -rf src

# 下载源码
wget --retry-connrefused --retry-on-host-error --retry-on-http-error=429,500,502,503,504 -t 10 -T 120 -O ${postgresql_path}/postgresql-${version}.7z ${download_url}/postgresql/postgresql-${version}.7z
wget --retry-connrefused --retry-on-host-error --retry-on-http-error=429,500,502,503,504 -t 10 -T 120 -O ${postgresql_path}/postgresql-${version}.7z.sha256 ${download_url}/postgresql/postgresql-${version}.7z.sha256

if ! sha256sum --status -c postgresql-${version}.7z.sha256; then
    rm -f postgresql-${version}.7z
    rm -f postgresql-${version}.7z.sha256
    error "PostgreSQL 校验失败"
fi

7z x postgresql-${version}.7z
rm -f postgresql-${version}.7z
rm -f postgresql-${version}.7z.sha256
mv postgresql-${version} src
chmod -R 700 src

# 编译
cd src
./configure --prefix=${postgresql_path} --enable-nls='zh_CN en' --with-icu --with-ssl=openssl --with-systemd --with-libxml --with-libxslt
if [ "$?" != "0" ]; then
    error "PostgreSQL 编译初始化失败"
fi
make "-j${j}"
if [ "$?" != "0" ]; then
    error "PostgreSQL 编译失败"
fi
make install
if [ "$?" != "0" ]; then
    error "PostgreSQL 安装失败"
fi

cd ${postgresql_path}
rm -rf ${postgresql_path}/src

# 配置
chown -R postgres:postgres ${postgresql_path}
chmod -R 700 ${postgresql_path}

# 启动服务
systemctl daemon-reload
systemctl start postgresql
if [ "$?" != "0" ]; then
    error "启动失败"
fi

panel-cli app write postgresql ${channel} ${version}

echo -e $HR
echo "升级完成"
echo -e $HR